"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorFloatHighlightToolbar = exports.HtmlEditorFloatHighlightToolbarContent = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@tiptap/react");
var lodash_1 = require("lodash");
var html_helper_1 = require("./html-helper");
var HtmlEditorFloatHighlightToolbarContent = function (props) {
    var editor = props.editor;
    var _a = (0, react_1.useState)(false), showInlineEditNoteUI = _a[0], setShowInlineEditNoteUI = _a[1];
    var InlineEditNoteUI = null;
    var colors = (0, lodash_1.isArray)(props.colors) && props.colors.length > 0 ? props.colors : [
        primeobjects_helper_util_1.COLORS.RED['100'],
        primeobjects_helper_util_1.COLORS.ORANGE['100'],
        primeobjects_helper_util_1.COLORS.BLUE['100'],
        primeobjects_helper_util_1.COLORS.GREEN['100'],
        primeobjects_helper_util_1.COLORS.GRAY['100'],
    ];
    var onClickEditNote = function () {
        var text = (0, html_helper_1.getSelectedHightlightText)(editor);
        if (!(0, lodash_1.isFunction)(props.onClickEditNote))
            return;
        InlineEditNoteUI = props.onClickEditNote(editor, text);
        setShowInlineEditNoteUI(true);
        //if result is not null, it is an inline editor, it will use the same block of tool bar
    };
    var onApplyColor = function (color) {
        var currentColor = (0, html_helper_1.getSelectedHightlightColor)(editor);
        if (currentColor == color) {
            editor.chain().focus().unsetHighlight().run();
        }
        else {
            editor.chain().focus().toggleHighlight({ color: color }).run();
        }
        if ((0, lodash_1.isFunction)(props.onHighlight))
            props.onHighlight(editor, color);
    };
    var renderColorPicker = function () {
        if (showInlineEditNoteUI)
            return null;
        var currentColor = (0, html_helper_1.getSelectedHightlightColor)(editor);
        return (0, lodash_1.map)(colors, function (color) {
            console.log({ currentColor: currentColor, color: color });
            var isActive = color == currentColor;
            return react_1.default.createElement("div", { className: "menu", key: color },
                react_1.default.createElement("div", { onClick: function () { return onApplyColor(color); }, style: { backgroundColor: color, margin: 2, marginTop: 4, marginBottom: 4, padding: 4 }, className: "menu-color ".concat(isActive ? 'active' : '') }, isActive && react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/checkmark.svg", size: 11 })));
        });
    };
    var renderEditNoteButton = function () {
        //if (!isFunction(props.onClickEditNote) || showInlineEditNoteUI) return null;
        return react_1.default.createElement("div", { className: "menu flex", style: { marginTop: 2, marginLeft: 2 } },
            react_1.default.createElement("div", { onClick: onClickEditNote, className: "menu-color", style: { width: 18, height: 18 } },
                react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/note.svg", size: 18 })));
    };
    var renderEditNoteUI = function () {
        return InlineEditNoteUI;
    };
    return react_1.default.createElement("div", { className: "menu w-full" },
        renderColorPicker(),
        renderEditNoteButton(),
        renderEditNoteUI());
};
exports.HtmlEditorFloatHighlightToolbarContent = HtmlEditorFloatHighlightToolbarContent;
var HtmlEditorFloatHighlightToolbar = function (props) {
    return (0, lodash_1.isNil)(props.editor) ? react_1.default.createElement(react_1.default.Fragment, null) : react_1.default.createElement(react_2.BubbleMenu, { editor: props.editor, className: "menu-wrapper highlight-toolbar" },
        react_1.default.createElement(exports.HtmlEditorFloatHighlightToolbarContent, __assign({}, props)));
};
exports.HtmlEditorFloatHighlightToolbar = HtmlEditorFloatHighlightToolbar;
exports.default = exports.HtmlEditorFloatHighlightToolbar;
